--- CVS/cperl-mode.el	2003-02-04 14:24:34.000000000 +0100
+++ pfeiffer/cperl-mode.el	2003-02-11 23:00:28.000000000 +0100
@@ -4437,9 +4414,9 @@
 
 (if (fboundp 'eval-after-load)
     (eval-after-load
-     "mode-compile"
-     '(setq perl-compilation-error-regexp-alist
-	   cperl-compilation-error-regexp-alist)))
+	"mode-compile"
+      '(setq perl-compilation-error-regexp-alist
+	     cperl-compilation-error-regexp-alist)))
 
 
 (defun cperl-windowed-init ()
@@ -4448,15 +4425,14 @@
       ;; Need to init anyway:
       (or cperl-faces-init (cperl-init-faces))
     (add-hook 'font-lock-mode-hook
-	      (function
-	       (lambda ()
-		 (if (memq major-mode '(perl-mode cperl-mode))
-		     (progn
-		       (or cperl-faces-init (cperl-init-faces)))))))
+	      (lambda ()
+		(if (memq major-mode '(perl-mode cperl-mode))
+		    (progn
+		      (or cperl-faces-init (cperl-init-faces))))))
     (if (fboundp 'eval-after-load)
 	(eval-after-load
-	 "ps-print"
-	 '(or cperl-faces-init (cperl-init-faces))))))
+	    "ps-print"
+	  '(or cperl-faces-init (cperl-init-faces))))))
 
 (defvar cperl-font-lock-keywords-1 nil
   "Additional expressions to highlight in Perl mode.  Minimal set.")
@@ -4633,7 +4609,7 @@
 	    '("[\[ \t{,(]\\(-?[a-zA-Z0-9_:]+\\)[ \t]*=>" 1
 	      font-lock-string-face t)
 	    '("^[ \t]*\\([a-zA-Z0-9_]+[ \t]*:\\)[ \t]*\\($\\|{\\|\\<\\(until\\|while\\|for\\(each\\)?\\|do\\)\\>\\)" 1
-	      font-lock-constant-face) ; labels
+	      font-lock-constant-face)	; labels
 	    '("\\<\\(continue\\|next\\|last\\|redo\\|goto\\)\\>[ \t]+\\([a-zA-Z0-9_:]+\\)" ; labels as targets
 	      2 font-lock-constant-face)
 	    ;; Uncomment to get perl-mode-like vars
@@ -4661,7 +4637,7 @@
 	  (setq
 	   t-font-lock-keywords-1
 	   (and (fboundp 'turn-on-font-lock) ; Check for newer font-lock
-		(not cperl-xemacs-p) ; not yet as of XEmacs 19.12
+		(not cperl-xemacs-p)	; not yet as of XEmacs 19.12
 		'(
 		  ("\\(\\([@%]\\|\$#\\)[a-zA-Z_:][a-zA-Z0-9_:]*\\)" 1
 		   (if (eq (char-after (match-beginning 2)) ?%)
@@ -4696,90 +4672,87 @@
 		  t-font-lock-keywords)
 		cperl-font-lock-keywords cperl-font-lock-keywords-1
 		cperl-font-lock-keywords-2 (append
-					   cperl-font-lock-keywords-1
-					   t-font-lock-keywords-1)))
+					    cperl-font-lock-keywords-1
+					    t-font-lock-keywords-1)))
 	(if (fboundp 'ps-print-buffer) (cperl-ps-print-init))
 	(if (or (featurep 'choose-color) (featurep 'font-lock-extra))
 	    (eval			; Avoid a warning
-	    '(font-lock-require-faces
-	     (list
-	      ;; Color-light    Color-dark      Gray-light      Gray-dark Mono
-	      (list 'font-lock-comment-face
-		    ["Firebrick"	"OrangeRed" 	"DimGray"	"Gray80"]
-		    nil
-		    [nil		nil		t		t	t]
-		    [nil		nil		t		t	t]
-		    nil)
-	      (list 'font-lock-string-face
-		    ["RosyBrown"	"LightSalmon" 	"Gray50"	"LightGray"]
-		    nil
-		    nil
-		    [nil		nil		t		t	t]
-		    nil)
-	      (list 'font-lock-function-name-face
-		    (vector
-		     "Blue"		"LightSkyBlue"	"Gray50"	"LightGray"
-		     (cdr (assq 'background-color ; if mono
-				(frame-parameters))))
-		    (vector
-		     nil		nil		nil		nil
-		     (cdr (assq 'foreground-color ; if mono
-				(frame-parameters))))
-		    [nil		nil		t		t	t]
-		    nil
-		    nil)
-	      (list 'font-lock-variable-name-face
-		    ["DarkGoldenrod"	"LightGoldenrod" "DimGray"	"Gray90"]
-		    nil
-		    [nil		nil		t		t	t]
-		    [nil		nil		t		t	t]
-		    nil)
-	      (list 'font-lock-type-face
-		    ["DarkOliveGreen"	"PaleGreen" 	"DimGray"	"Gray80"]
-		    nil
-		    [nil		nil		t		t	t]
-		    nil
-		    [nil		nil		t		t	t]
-		    )
-	      (list 'font-lock-constant-face
-		    ["CadetBlue"	"Aquamarine" 	"Gray50"	"LightGray"]
-		    nil
-		    [nil		nil		t		t	t]
-		    nil
-		    [nil		nil		t		t	t]
-		    )
-	      (list 'cperl-nonoverridable-face
-		    ["chartreuse3"	("orchid1" "orange")
-		     nil		"Gray80"]
-		    [nil		nil		"gray90"]
-		    [nil		nil		nil		t	t]
-		    [nil		nil		t		t]
-		    [nil		nil		t		t	t]
-		    )
-	      (list 'cperl-array-face
-		    ["blue"		"yellow" 	nil		"Gray80"]
-		    ["lightyellow2"	("navy" "os2blue" "darkgreen")
-		     "gray90"]
-		    t
-		    nil
-		    nil)
-	      (list 'cperl-hash-face
-		    ["red"		"red"	 	nil		"Gray80"]
-		    ["lightyellow2"	("navy" "os2blue" "darkgreen")
-		     "gray90"]
-		    t
-		    t
-		    nil))))
+	     '(font-lock-require-faces
+	       (list
+		;; Color-light    Color-dark      Gray-light      Gray-dark Mono
+		(list 'font-lock-comment-face
+		      ["Firebrick"	"OrangeRed" 	"DimGray"	"Gray80"]
+		      nil
+		      [nil		nil		t		t	t]
+		      [nil		nil		t		t	t]
+		      nil)
+		(list 'font-lock-string-face
+		      ["RosyBrown"	"LightSalmon" 	"Gray50"	"LightGray"]
+		      nil
+		      nil
+		      [nil		nil		t		t	t]
+		      nil)
+		(list 'font-lock-function-name-face
+		      (vector
+		       "Blue"		"LightSkyBlue"	"Gray50"	"LightGray"
+		       (cdr (assq 'background-color ; if mono
+				  (frame-parameters))))
+		      (vector
+		       nil		nil		nil		nil
+		       (cdr (assq 'foreground-color ; if mono
+				  (frame-parameters))))
+		      [nil		nil		t		t	t]
+		      nil
+		      nil)
+		(list 'font-lock-variable-name-face
+		      ["DarkGoldenrod"	"LightGoldenrod" "DimGray"	"Gray90"]
+		      nil
+		      [nil		nil		t		t	t]
+		      [nil		nil		t		t	t]
+		      nil)
+		(list 'font-lock-type-face
+		      ["DarkOliveGreen"	"PaleGreen" 	"DimGray"	"Gray80"]
+		      nil
+		      [nil		nil		t		t	t]
+		      nil
+		      [nil		nil		t		t	t])
+		(list 'font-lock-constant-face
+		      ["CadetBlue"	"Aquamarine" 	"Gray50"	"LightGray"]
+		      nil
+		      [nil		nil		t		t	t]
+		      nil
+		      [nil		nil		t		t	t])
+		(list 'cperl-nonoverridable-face
+		      ["chartreuse3"	("orchid1" "orange")
+		       nil		"Gray80"]
+		      [nil		nil		"gray90"]
+		      [nil		nil		nil		t	t]
+		      [nil		nil		t		t]
+		      [nil		nil		t		t	t])
+		(list 'cperl-array-face
+		      ["blue"		"yellow" 	nil		"Gray80"]
+		      ["lightyellow2"	("navy" "os2blue" "darkgreen")
+		       "gray90"]
+		      t
+		      nil
+		      nil)
+		(list 'cperl-hash-face
+		      ["red"		"red"	 	nil		"Gray80"]
+		      ["lightyellow2"	("navy" "os2blue" "darkgreen")
+		       "gray90"]
+		      t
+		      t
+		      nil))))
 	  ;; Do it the dull way, without choose-color
 	  (defvar cperl-guessed-background nil
 	    "Display characteristics as guessed by cperl.")
-;;	  (or (fboundp 'x-color-defined-p)
-;;	      (defalias 'x-color-defined-p
-;;		(cond ((fboundp 'color-defined-p) 'color-defined-p)
-;;		      ;; XEmacs >= 19.12
-;;		      ((fboundp 'valid-color-name-p) 'valid-color-name-p)
-;;		      ;; XEmacs 19.11
-;;		      (t 'x-valid-color-name-p))))
+	  ;;	  (or (fboundp 'x-color-defined-p)
+	  ;;	      (defalias 'x-color-defined-p
+	  ;;		(cond ((fboundp 'color-defined-p) 'color-defined-p)
+	  ;;		      ;; XEmacs >= 19.12
+	  ;;		      ((fboundp 'valid-color-name-p) 'valid-color-name-p)
+	  ;;		      ;; XEmacs 19.11
+	  ;;		      (t 'x-valid-color-name-p))))
 	  (cperl-force-face font-lock-constant-face
 			    "Face for constant and label names")
 	  (cperl-force-face font-lock-variable-name-face
@@ -4846,9 +4819,7 @@
 		 (if (boundp 'font-lock-background-mode)
 		     font-lock-background-mode
 		   'light))
-		(face-list (and (fboundp 'face-list) (face-list)))
-		;; cperl-is-face
-		)
+		(face-list (and (fboundp 'face-list) (face-list))))
 ;;;;	    (fset 'cperl-is-face
 ;;;;		  (cond ((fboundp 'find-face)
 ;;;;			 (symbol-function 'find-face))
@@ -4862,10 +4833,9 @@
 		  'gray
 		background)
 	      "Background as guessed by CPerl mode")
-	    (if (and
-		 (not (cperl-is-face 'font-lock-constant-face))
-		 (cperl-is-face 'font-lock-reference-face))
-	      (copy-face 'font-lock-reference-face 'font-lock-constant-face))
+	    (and (not (cperl-is-face 'font-lock-constant-face))
+		 (cperl-is-face 'font-lock-reference-face)
+		 (copy-face 'font-lock-reference-face 'font-lock-constant-face))
 	    (if (cperl-is-face 'font-lock-type-face) nil
 	      (copy-face 'default 'font-lock-type-face)
 	      (cond
@@ -5023,7 +4993,7 @@
     cperl-continued-statement-offset))
 
 (defconst cperl-style-alist
-  '(("CPerl" ; =GNU without extra-newline-before-brace
+  '(("CPerl"			     ; =GNU without extra-newline-before-brace
      (cperl-indent-level               .  2)
      (cperl-brace-offset               .  0)
      (cperl-continued-brace-offset     .  0)
@@ -5031,7 +5001,7 @@
      (cperl-extra-newline-before-brace .  nil)
      (cperl-merge-trailing-else	       .  t)
      (cperl-continued-statement-offset .  2))
-    ("PerlStyle" ; CPerl with 4 as indent
+    ("PerlStyle"			; CPerl with 4 as indent
      (cperl-indent-level               .  4)
      (cperl-brace-offset               .  0)
      (cperl-continued-brace-offset     .  0)
@@ -5093,14 +5063,13 @@
 Chosing \"Current\" style will not change style, so this may be used for
 side-effect of memorizing only."
   (interactive
-   (let ((list (mapcar (function (lambda (elt) (list (car elt))))
+   (let ((list (mapcar (lambda (elt) (list (car elt)))
 		       cperl-style-alist)))
      (list (completing-read "Enter style: " list nil 'insist))))
   (or cperl-old-style
       (setq cperl-old-style
-	    (mapcar (function
-		     (lambda (name)
-		       (cons name (eval name))))
+	    (mapcar (lambda (name)
+		      (cons name (eval name)))
 		    cperl-styles-entries)))
   (let ((style (cdr (assoc style cperl-style-alist))) setting str sym)
     (while style
@@ -5172,11 +5141,11 @@
   (interactive
    (let* ((default (cperl-word-at-point))
 	  (read (read-string
-		     (format "Find doc for Perl function (default %s): "
-			     default))))
+		 (format "Find doc for Perl function (default %s): "
+			 default))))
      (list (if (equal read "")
-		   default
-		 read))))
+	       default
+	     read))))
 
   (let ((buffer (current-buffer))
 	(cmd-desc (concat "^" (regexp-quote command) "[^a-zA-Z_0-9]")) ; "tr///"
@@ -5235,8 +5204,7 @@
 			 ;; Non-functioning under OS/2:
 			 (if (eq char-height 1) (setq char-height 18))
 			 ;; Title, menubar, + 2 for slack
-			 (- (/ (x-display-pixel-height) char-height) 4)
-			 ))
+			 (- (/ (x-display-pixel-height) char-height) 4)))
 		 (if (> height max-height) (setq height max-height))
 		 ;;(message "was %s doing %s" iniheight height)
 		 (if not-loner
@@ -5343,7 +5311,7 @@
 	    (setq e (point))
 	    (skip-chars-backward " \t")
 	    (delete-region (point) e)
-	    (indent-to-column col); (make-string (- col (current-column)) ?\ ))
+	    (indent-to-column col) ; (make-string (- col (current-column)) ?\ ))
 	    (beginning-of-line 2)
 	    (and (< (point) end)
 		 (re-search-forward search end t)
@@ -5458,7 +5426,7 @@
 	(or noninteractive
 	    (imenu-progress-message prev-pos))
 	(cond
-	 ((match-beginning 2)	; SECTION
+	 ((match-beginning 2)		; SECTION
 	  (setq package (buffer-substring (match-beginning 2) (match-end 2)))
 	  (goto-char (match-beginning 0))
 	  (skip-chars-forward " \t")
@@ -5491,11 +5459,11 @@
 (defvar cperl-unreadable-ok nil)
 
 (defun cperl-find-tags (ifile xs topdir)
-  (let (ind (b (get-buffer cperl-tmp-buffer)) lst elt pos ret rel
-	    (cperl-pod-here-fontify nil) f file)
+  (let ((b (get-buffer cperl-tmp-buffer)) ind lst elt pos ret rel
+	(cperl-pod-here-fontify nil) f file)
     (save-excursion
       (if b (set-buffer b)
-	  (cperl-setup-tmp-buf))
+	(cperl-setup-tmp-buf))
       (erase-buffer)
       (condition-case err
 	  (setq file (car (insert-file-contents ifile)))
@@ -5506,72 +5474,71 @@
 		   (error "Aborting: unreadable file %s" ifile)))))
       (if (not file)
 	  (message "Unreadable file %s" ifile)
-      (message "Scanning file %s ..." file)
-      (if (and cperl-use-syntax-table-text-property-for-tags
-	       (not xs))
-	  (condition-case err		; after __END__ may have garbage
-	      (cperl-find-pods-heres nil nil noninteractive)
-	    (error (message "While scanning for syntax: %s" err))))
-      (if xs
-	  (setq lst (cperl-xsub-scan))
-	(setq ind (cperl-imenu--create-perl-index))
-	(setq lst (cdr (assoc "+Unsorted List+..." ind))))
-      (setq lst
-	    (mapcar
-	     (function
-	      (lambda (elt)
-		(cond ((string-match "^[_a-zA-Z]" (car elt))
-		       (goto-char (cdr elt))
-		       (beginning-of-line) ; pos should be of the start of the line
-		       (list (car elt)
-			     (point)
-			     (1+ (count-lines 1 (point))) ; 1+ since at beg-o-l
-			     (buffer-substring (progn
-						 (goto-char (cdr elt))
-						 ;; After name now...
-						 (or (eolp) (forward-char 1))
-						 (point))
-					       (progn
-						 (beginning-of-line)
-						 (point))))))))
-		    lst))
-      (erase-buffer)
-      (while lst
-	(setq elt (car lst) lst (cdr lst))
-	(if elt
-	    (progn
-	      (insert (elt elt 3)
-		      127
-		      (if (string-match "^package " (car elt))
-			  (substring (car elt) 8)
-			(car elt) )
-		      1
-		      (number-to-string (elt elt 2)) ; Line
-		      ","
-		      (number-to-string (1- (elt elt 1))) ; Char pos 0-based
-		      "\n")
-	      (if (and (string-match "^[_a-zA-Z]+::" (car elt))
-		       (string-match "^sub[ \t]+\\([_a-zA-Z]+\\)[^:_a-zA-Z]"
-				     (elt elt 3)))
-		  ;; Need to insert the name without package as well
-		  (setq lst (cons (cons (substring (elt elt 3)
-						   (match-beginning 1)
-						   (match-end 1))
-					(cdr elt))
-				  lst))))))
-      (setq pos (point))
-      (goto-char 1)
-      (setq rel file)
-      ;; On case-preserving filesystems (EMX on OS/2) case might be encoded in properties
-      (set-text-properties 0 (length rel) nil rel)
-      (and (equal topdir (substring rel 0 (length topdir)))
-	   (setq rel (substring file (length topdir))))
-      (insert "\f\n" rel "," (number-to-string (1- pos)) "\n")
-      (setq ret (buffer-substring 1 (point-max)))
-      (erase-buffer)
-      (or noninteractive
-	  (message "Scanning file %s finished" file))
-      ret))))
+	(message "Scanning file %s ..." file)
+	(if (and cperl-use-syntax-table-text-property-for-tags
+		 (not xs))
+	    (condition-case err		; after __END__ may have garbage
+		(cperl-find-pods-heres nil nil noninteractive)
+	      (error (message "While scanning for syntax: %s" err))))
+	(if xs
+	    (setq lst (cperl-xsub-scan))
+	  (setq ind (cperl-imenu--create-perl-index))
+	  (setq lst (cdr (assoc "+Unsorted List+..." ind))))
+	(setq lst
+	      (mapcar
+	       (lambda (elt)
+		 (cond ((string-match "^[_a-zA-Z]" (car elt))
+			(goto-char (cdr elt))
+			(beginning-of-line) ; pos should be of the start of the line
+			(list (car elt)
+			      (point)
+			      (1+ (count-lines 1 (point))) ; 1+ since at beg-o-l
+			      (buffer-substring (progn
+						  (goto-char (cdr elt))
+						  ;; After name now...
+						  (or (eolp) (forward-char 1))
+						  (point))
+						(progn
+						  (beginning-of-line)
+						  (point)))))))
+	       lst))
+	(erase-buffer)
+	(while lst
+	  (setq elt (car lst) lst (cdr lst))
+	  (if elt
+	      (progn
+		(insert (elt elt 3)
+			127
+			(if (string-match "^package " (car elt))
+			    (substring (car elt) 8)
+			  (car elt) )
+			1
+			(number-to-string (elt elt 2)) ; Line
+			","
+			(number-to-string (1- (elt elt 1))) ; Char pos 0-based
+			"\n")
+		(if (and (string-match "^[_a-zA-Z]+::" (car elt))
+			 (string-match "^sub[ \t]+\\([_a-zA-Z]+\\)[^:_a-zA-Z]"
+				       (elt elt 3)))
+		    ;; Need to insert the name without package as well
+		    (setq lst (cons (cons (substring (elt elt 3)
+						     (match-beginning 1)
+						     (match-end 1))
+					  (cdr elt))
+				    lst))))))
+	(setq pos (point))
+	(goto-char 1)
+	(setq rel file)
+	;; On case-preserving filesystems (EMX on OS/2) case might be encoded in properties
+	(set-text-properties 0 (length rel) nil rel)
+	(and (equal topdir (substring rel 0 (length topdir)))
+	     (setq rel (substring file (length topdir))))
+	(insert "\f\n" rel "," (number-to-string (1- pos)) "\n")
+	(setq ret (buffer-substring 1 (point-max)))
+	(erase-buffer)
+	(or noninteractive
+	    (message "Scanning file %s finished" file))
+	ret))))
 
 (defun cperl-add-tags-recurse-noxs ()
   "Add to TAGS data for Perl and XSUB files in the current directory and kids.
@@ -5606,7 +5573,7 @@
 	    ((file-exists-p tags-file-name)
 	     (if cperl-xemacs-p
 		 (visit-tags-table-buffer)
-	      (visit-tags-table-buffer tags-file-name)))
+	       (visit-tags-table-buffer tags-file-name)))
 	    (t (set-buffer (find-file-noselect tags-file-name))))
       (cond
        (dir
@@ -5624,46 +5591,45 @@
 		    (if (y-or-n-p
 			 (format "Directory %s unreadable.  Continue? " file))
 			(setq cperl-unreadable-ok t
-			      tm nil) ; Return empty list
+			      tm nil)	; Return empty list
 		      (error "Aborting: unreadable directory %s" file)))))))
-	  (mapcar (function (lambda (file)
-			      (cond
-			       ((string-match cperl-noscan-files-regexp file)
-				nil)
-			       ((not (file-directory-p file))
-				(if (string-match cperl-scan-files-regexp file)
-				    (cperl-write-tags file erase recurse nil t noxs topdir)))
-			       ((not recurse) nil)
-			       (t (cperl-write-tags file erase recurse t t noxs topdir)))))
-		  files))
-	)
+	  (mapcar (lambda (file)
+		    (cond
+		     ((string-match cperl-noscan-files-regexp file)
+		      nil)
+		     ((not (file-directory-p file))
+		      (if (string-match cperl-scan-files-regexp file)
+			  (cperl-write-tags file erase recurse nil t noxs topdir)))
+		     ((not recurse) nil)
+		     (t (cperl-write-tags file erase recurse t t noxs topdir))))
+		  files)))
        (t
 	(setq xs (string-match "\\.xs$" file))
 	(if (not (and xs noxs))
 	    (progn
 	      (cond ((eq erase 'ignore) (goto-char (point-max)))
-		  (erase (erase-buffer))
-		  (t
-		   (goto-char 1)
-		   (setq rel file)
-		   ;; On case-preserving filesystems (EMX on OS/2) case might be encoded in properties
-		   (set-text-properties 0 (length rel) nil rel)
-		   (and (equal topdir (substring rel 0 (length topdir)))
-			(setq rel (substring file (length topdir))))
-		   (if (search-forward (concat "\f\n" rel ",") nil t)
-		       (progn
-			 (search-backward "\f\n")
-			 (delete-region (point)
-					(save-excursion
-					  (forward-char 1)
-					  (if (search-forward "\f\n"
-							      nil 'toend)
-					      (- (point) 2)
-					    (point-max)))))
-		     (goto-char (point-max)))))
+		    (erase (erase-buffer))
+		    (t
+		     (goto-char 1)
+		     (setq rel file)
+		     ;; On case-preserving filesystems (EMX on OS/2) case might be encoded in properties
+		     (set-text-properties 0 (length rel) nil rel)
+		     (and (equal topdir (substring rel 0 (length topdir)))
+			  (setq rel (substring file (length topdir))))
+		     (if (search-forward (concat "\f\n" rel ",") nil t)
+			 (progn
+			   (search-backward "\f\n")
+			   (delete-region (point)
+					  (save-excursion
+					    (forward-char 1)
+					    (if (search-forward "\f\n"
+								nil 'toend)
+						(- (point) 2)
+					      (point-max)))))
+		       (goto-char (point-max)))))
 	      (insert (cperl-find-tags file xs topdir))))))
-      (if inbuffer nil		; Delegate to the caller
-	(save-buffer 0)		; No backup
+      (if inbuffer nil			; Delegate to the caller
+	(save-buffer 0)			; No backup
 	(if (fboundp 'initialize-new-tags-table) ; Do we need something special in XEmacs?
 	    (initialize-new-tags-table))))))
 
@@ -5733,30 +5699,29 @@
   (require 'etags)
   (require 'imenu)
   (if (or update (null (nth 2 cperl-hierarchy)))
-      (let (pack name cons1 to l1 l2 l3 l4 b
-		 (remover (function (lambda (elt) ; (name (file1...) (file2..))
-				      (or (nthcdr 2 elt)
-					  ;; Only in one file
-					  (setcdr elt (cdr (nth 1 elt))))))))
+      (let ((remover (lambda (elt) ; (name (file1...) (file2..))
+		       (or (nthcdr 2 elt)
+			   ;; Only in one file
+			   (setcdr elt (cdr (nth 1 elt))))))
+	    pack name cons1 to l1 l2 l3 l4 b)
 	;; (setq cperl-hierarchy '(() () ())) ; Would write into '() later!
 	(setq cperl-hierarchy (list l1 l2 l3))
 	(if cperl-xemacs-p		; Not checked
 	    (progn
 	      (or tags-file-name
 		  ;; Does this work in XEmacs?
-	    (call-interactively 'visit-tags-table))
-	(message "Updating list of classes...")
+		  (call-interactively 'visit-tags-table))
+	      (message "Updating list of classes...")
 	      (set-buffer (get-file-buffer tags-file-name))
 	      (cperl-tags-hier-fill))
 	  (or tags-table-list
 	      (call-interactively 'visit-tags-table))
-	(mapcar
-	 (function
-	  (lambda (tagsfile)
-	      (message "Updating list of classes... %s" tagsfile)
-	    (set-buffer (get-file-buffer tagsfile))
-	    (cperl-tags-hier-fill)))
-	 tags-table-list)
+	  (mapcar
+	   (lambda (tagsfile)
+	     (message "Updating list of classes... %s" tagsfile)
+	     (set-buffer (get-file-buffer tagsfile))
+	     (cperl-tags-hier-fill))
+	   tags-table-list)
 	  (message "Updating list of classes... postprocessing..."))
 	(mapcar remover (car cperl-hierarchy))
 	(mapcar remover (nth 1 cperl-hierarchy))
@@ -5797,26 +5762,25 @@
 	 l1 head tail cons1 cons2 ord writeto packs recurse
 	 root-packages root-functions ms many_ms same_name ps
 	 (move-deeper
-	  (function
-	   (lambda (elt)
-	     (cond ((and (string-match regexp (car elt))
-			 (or (eq ord 1) (match-end 2)))
-		    (setq head (substring (car elt) 0 (match-end 1))
-			  tail (if (match-end 2) (substring (car elt)
-							    (match-end 2)))
-			  recurse t)
-		    (if (setq cons1 (assoc head writeto)) nil
-		      ;; Need to init new head
-		      (setcdr writeto (cons (list head (list "Packages: ")
-						  (list "Methods: "))
-					    (cdr writeto)))
-		      (setq cons1 (nth 1 writeto)))
-		    (setq cons2 (nth ord cons1)) ; Either packs or meths
-		    (setcdr cons2 (cons elt (cdr cons2))))
-		   ((eq ord 2)
-		    (setq root-functions (cons elt root-functions)))
-		   (t
-		    (setq root-packages (cons elt root-packages))))))))
+	  (lambda (elt)
+	    (cond ((and (string-match regexp (car elt))
+			(or (eq ord 1) (match-end 2)))
+		   (setq head (substring (car elt) 0 (match-end 1))
+			 tail (if (match-end 2) (substring (car elt)
+							   (match-end 2)))
+			 recurse t)
+		   (if (setq cons1 (assoc head writeto)) nil
+		     ;; Need to init new head
+		     (setcdr writeto (cons (list head (list "Packages: ")
+						 (list "Methods: "))
+					   (cdr writeto)))
+		     (setq cons1 (nth 1 writeto)))
+		   (setq cons2 (nth ord cons1)) ; Either packs or meths
+		   (setcdr cons2 (cons elt (cdr cons2))))
+		  ((eq ord 2)
+		   (setq root-functions (cons elt root-functions)))
+		  (t
+		   (setq root-packages (cons elt root-packages)))))))
     (setcdr to l1)			; Init to dynamic space
     (setq writeto to)
     (setq ord 1)
@@ -5824,37 +5788,36 @@
     (setq ord 2)
     (mapcar move-deeper methods)
     (if recurse
-	(mapcar (function (lambda (elt)
-			  (cperl-tags-treeify elt (1+ level))))
+	(mapcar (lambda (elt)
+		  (cperl-tags-treeify elt (1+ level)))
 		(cdr to)))
     ;;Now clean up leaders with one child only
-    (mapcar (function (lambda (elt)
-			(if (not (and (listp (cdr elt))
-				      (eq (length elt) 2))) nil
-			    (setcar elt (car (nth 1 elt)))
-			    (setcdr elt (cdr (nth 1 elt))))))
+    (mapcar (lambda (elt)
+	      (if (not (and (listp (cdr elt))
+			    (eq (length elt) 2))) nil
+		(setcar elt (car (nth 1 elt)))
+		(setcdr elt (cdr (nth 1 elt)))))
 	    (cdr to))
     ;; Sort the roots of subtrees
     (if (default-value 'imenu-sort-function)
 	(setcdr to
 		(sort (cdr to) (default-value 'imenu-sort-function))))
     ;; Now add back functions removed from display
-    (mapcar (function (lambda (elt)
-			(setcdr to (cons elt (cdr to)))))
+    (mapcar (lambda (elt)
+	      (setcdr to (cons elt (cdr to))))
 	    (if (default-value 'imenu-sort-function)
 		(nreverse
 		 (sort root-functions (default-value 'imenu-sort-function)))
 	      root-functions))
     ;; Now add back packages removed from display
-    (mapcar (function (lambda (elt)
-			(setcdr to (cons (cons (concat "package " (car elt))
-					       (cdr elt))
-					 (cdr to)))))
+    (mapcar (lambda (elt)
+	      (setcdr to (cons (cons (concat "package " (car elt))
+				     (cdr elt))
+			       (cdr to))))
 	    (if (default-value 'imenu-sort-function)
 		(nreverse
 		 (sort root-packages (default-value 'imenu-sort-function)))
-	      root-packages))
-    ))
+	      root-packages))))
 
 ;;;(x-popup-menu t
 ;;;   '(keymap "Name1"
@@ -5886,52 +5849,50 @@
   (let (list)
     (cons 'keymap
 	  (mapcar
-	   (function
-	    (lambda (elt)
-	      (cond ((listp (cdr elt))
-		     (setq list (cperl-list-fold
-				 (cdr elt) (car elt) imenu-max-items))
-		     (cons nil
-			   (cons (car elt)
-				 (cperl-menu-to-keymap list))))
-		    (t
-		     (list (cdr elt) (car elt) t))))) ; t is needed in 19.34
+	   (lambda (elt)
+	     (cond ((listp (cdr elt))
+		    (setq list (cperl-list-fold
+				(cdr elt) (car elt) imenu-max-items))
+		    (cons nil
+			  (cons (car elt)
+				(cperl-menu-to-keymap list))))
+		   (t
+		    (list (cdr elt) (car elt) t)))) ; t is needed in 19.34
 	   (cperl-list-fold menu "Root" imenu-max-items)))))
 
 
 (defvar cperl-bad-style-regexp
   (mapconcat 'identity
-   '("[^-\n\t <>=+!.&|(*/'`\"#^][-=+<>!|&^]" ; char sign
-     "[-<>=+^&|]+[^- \t\n=+<>~]"	; sign+ char
-     )
-   "\\|")
+	     '("[^-\n\t <>=+!.&|(*/'`\"#^][-=+<>!|&^]" ; char sign
+	       "[-<>=+^&|]+[^- \t\n=+<>~]") ; sign+ char 
+	     "\\|")
   "Finds places such that insertion of a whitespace may help a lot.")
 
 (defvar cperl-not-bad-style-regexp
   (mapconcat 'identity
-   '("[^-\t <>=+]\\(--\\|\\+\\+\\)"	; var-- var++
-     "[a-zA-Z0-9_][|&][a-zA-Z0-9_$]"	; abc|def abc&def are often used.
-     "&[(a-zA-Z0-9_$]"			; &subroutine &(var->field)
-     "<\\$?\\sw+\\(\\.\\sw+\\)?>"	; <IN> <stdin.h>
-     "-[a-zA-Z][ \t]+[_$\"'`a-zA-Z]"	; -f file, -t STDIN
-     "-[0-9]"				; -5
-     "\\+\\+"				; ++var
-     "--"				; --var
-     ".->"				; a->b
-     "->"				; a SPACE ->b
-     "\\[-"				; a[-1]
-     "\\\\[&$@*\\\\]"			; \&func
-     "^="				; =head
-     "\\$."				; $|
-     "<<[a-zA-Z_'\"`]"			; <<FOO, <<'FOO'
-     "||"
-     "&&"
-     "[CBIXSLFZ]<\\(\\sw\\|\\s \\|\\s_\\|[\n]\\)*>" ; C<code like text>
-     "-[a-zA-Z_0-9]+[ \t]*=>"			; -option => value
-     ;; Unaddressed trouble spots: = -abc, f(56, -abc) --- specialcased below
-     ;;"[*/+-|&<.]+="
-     )
-   "\\|")
+	     '("[^-\t <>=+]\\(--\\|\\+\\+\\)" ; var-- var++
+	       "[a-zA-Z0-9_][|&][a-zA-Z0-9_$]" ; abc|def abc&def are often used.
+	       "&[(a-zA-Z0-9_$]"	; &subroutine &(var->field)
+	       "<\\$?\\sw+\\(\\.\\sw+\\)?>" ; <IN> <stdin.h>
+	       "-[a-zA-Z][ \t]+[_$\"'`a-zA-Z]" ; -f file, -t STDIN
+	       "-[0-9]"			; -5
+	       "\\+\\+"			; ++var
+	       "--"			; --var
+	       ".->"			; a->b
+	       "->"			; a SPACE ->b
+	       "\\[-"			; a[-1]
+	       "\\\\[&$@*\\\\]"		; \&func
+	       "^="			; =head
+	       "\\$."			; $|
+	       "<<[a-zA-Z_'\"`]"	; <<FOO, <<'FOO'
+	       "||"
+	       "&&"
+	       "[CBIXSLFZ]<\\(\\sw\\|\\s \\|\\s_\\|[\n]\\)*>" ; C<code like text>
+	       "-[a-zA-Z_0-9]+[ \t]*=>"	; -option => value
+	       ;; Unaddressed trouble spots: = -abc, f(56, -abc) --- specialcased below
+	       ;;"[*/+-|&<.]+="
+	       )
+	     "\\|")
   "If matches at the start of match found by `my-bad-c-style-regexp',
 insertion of a whitespace will not help.")
 
@@ -5946,7 +5907,7 @@
     (setq last-nonmenu-event 13)	; To disable popup
     (beginning-of-buffer)
     (map-y-or-n-p "Insert space here? "
-		  (function (lambda (arg) (insert " ")))
+		  (lambda (arg) (insert " "))
 		  'cperl-next-bad-style
 		  '("location" "locations" "insert a space into")
 		  '((?\C-r (lambda (arg)
@@ -5999,22 +5960,20 @@
   ;;(concat "\\("
   (mapconcat
    'identity
-   '("[$@%*&][0-9a-zA-Z_:]+\\([ \t]*[[{]\\)?"		; Usual variable
+   '("[$@%*&][0-9a-zA-Z_:]+\\([ \t]*[[{]\\)?" ; Usual variable
      "[$@]\\^[a-zA-Z]"			; Special variable
      "[$@][^ \n\t]"			; Special variable
      "-[a-zA-Z]"			; File test
      "\\\\[a-zA-Z0]"			; Special chars
-     "^=[a-z][a-zA-Z0-9_]*"		; Pod sections
+     "^=[a-z][a-zA-Z0-9_]*"		; POD sections
      "[-!&*+,-./<=>?\\\\^|~]+"		; Operator
      "[a-zA-Z_0-9:]+"			; symbol or number
      "x="
-     "#!"
-     )
+     "#!")
    ;;"\\)\\|\\("
-   "\\|"
-   )
-	  ;;"\\)"
-	  ;;)
+   "\\|")
+  ;;"\\)"
+  ;;)
   "Matches places in the buffer we can find help for.")
 
 (defvar cperl-message-on-help-error t)
@@ -6102,22 +6061,22 @@
   (let ((enable-recursive-minibuffers t)
 	args-file regexp)
     (cond
-	((string-match "^[&*][a-zA-Z_]" val)
-	 (setq val (concat (substring val 0 1) "NAME")))
-	((string-match "^[$@]\\([a-zA-Z_:0-9]+\\)[ \t]*\\[" val)
-	 (setq val (concat "@" (substring val 1 (match-end 1)))))
-	((string-match "^[$@]\\([a-zA-Z_:0-9]+\\)[ \t]*{" val)
-	 (setq val (concat "%" (substring val 1 (match-end 1)))))
-	((and (string= val "x") (string-match "^x=" val))
-	 (setq val "x="))
-	((string-match "^\\$[\C-a-\C-z]" val)
-	 (setq val (concat "$^" (char-to-string (+ ?A -1 (aref val 1))))))
-        ((string-match "^CORE::" val)
-	 (setq val "CORE::"))
-        ((string-match "^SUPER::" val)
-	 (setq val "SUPER::"))
-	((and (string= "<" val) (string-match "^<\\$?[a-zA-Z0-9_:]+>" val))
-	 (setq val "<NAME>")))
+     ((string-match "^[&*][a-zA-Z_]" val)
+      (setq val (concat (substring val 0 1) "NAME")))
+     ((string-match "^[$@]\\([a-zA-Z_:0-9]+\\)[ \t]*\\[" val)
+      (setq val (concat "@" (substring val 1 (match-end 1)))))
+     ((string-match "^[$@]\\([a-zA-Z_:0-9]+\\)[ \t]*{" val)
+      (setq val (concat "%" (substring val 1 (match-end 1)))))
+     ((and (string= val "x") (string-match "^x=" val))
+      (setq val "x="))
+     ((string-match "^\\$[\C-a-\C-z]" val)
+      (setq val (concat "$^" (char-to-string (+ ?A -1 (aref val 1))))))
+     ((string-match "^CORE::" val)
+      (setq val "CORE::"))
+     ((string-match "^SUPER::" val)
+      (setq val "SUPER::"))
+     ((and (string= "<" val) (string-match "^<\\$?[a-zA-Z0-9_:]+>" val))
+      (setq val "<NAME>")))
     (setq regexp (concat "^"
 			 "\\([^a-zA-Z0-9_:]+[ \t]+\\)?"
 			 (regexp-quote val)
@@ -6139,7 +6098,7 @@
 	 (if cperl-message-on-help-error
 	     (message "No definition for %s" val)))))))
 
-(defvar cperl-short-docs "Ignore my value"
+(defvar cperl-short-docs 'please-ignore-this-line
   ;; Perl4 version was written by Johan Vromans (jvromans@squirrel.nl)
   "# based on '@(#)@ perl-descr.el 1.9 - describe-perl-symbol' [Perl 5]
 ! ...	Logical negation.
@@ -6512,12 +6471,6 @@
 CORE::		Prefix to access builtin function if imported sub obscures it.
 SUPER::		Prefix to lookup for a method in @ISA classes.
 DESTROY		Shorthand for `sub DESTROY {...}'.
-... EQ ...	Obsolete synonym of `eq'.
-... GE ...	Obsolete synonym of `ge'.
-... GT ...	Obsolete synonym of `gt'.
-... LE ...	Obsolete synonym of `le'.
-... LT ...	Obsolete synonym of `lt'.
-... NE ...	Obsolete synonym of `ne'.
 abs [ EXPR ]	absolute value
 ... and ...		Low-precedence synonym for &&.
 bless REFERENCE [, PACKAGE]	Makes reference into an object of a package.
@@ -6525,7 +6478,7 @@
 chr		Converts a number to char with the same ordinal.
 else		Part of if/unless {BLOCK} elsif {BLOCK} else {BLOCK}.
 elsif		Part of if/unless {BLOCK} elsif {BLOCK} else {BLOCK}.
-exists	$HASH{KEY}	True if the key exists.
+exists $HASH{KEY}	True if the key exists.
 format [NAME] =	 Start of output format.  Ended by a single dot (.) on a line.
 formline PICTURE, LIST	Backdoor into \"format\" processing.
 glob EXPR	Synonym of <EXPR>.
@@ -6603,7 +6556,7 @@
     (goto-char e)
     (beginning-of-line)
     (if (re-search-forward "[^ \t]" e t)
-	(progn				; Something before the ending delimiter
+	(progn			       ; Something before the ending delimiter
 	  (goto-char e)
 	  (delete-horizontal-space)
 	  (insert "\n")
